  <!DOCTYPE html>
  <meta charset="utf-8" />
  <title>WebSocket Test</title>
  <script
        src="https://code.jquery.com/jquery-2.2.4.min.js"
        integrity="sha256-BbhdlvQf/xTY9gja0Dq3HiwQF8LaCRTXxZKRutelT44="
        crossorigin="anonymous"></script>
  <script language="javascript" type="text/javascript">

  var wsUri = "ws://192.168.99.96:7272";
  var output;

  var jsonString;

  var mySetting = mySetting || {};
  mySetting = {
    id : "u_2"
  };


  var register = register || {};
  register = {
    chatID : mySetting.id,
    action : "register",
    content : "register"
  };

  var message = message || {};
  message = {
    content : "",
    fromChatID : mySetting.id,
    toChatID : "",
    action : "message"
  };

  function init()
  {
    output = document.getElementById("output");
    testWebSocket();
  }

  function testWebSocket()
  {
    websocket = new WebSocket(wsUri);
    websocket.onopen = function(evt) { onOpen(evt) };
    websocket.onclose = function(evt) { onClose(evt) };
    websocket.onmessage = function(evt) { onMessage(evt) };
    websocket.onerror = function(evt) { onError(evt) };



    $('#text').keypress(function (event) {
      if (event.keyCode == 13) {
        $("#send_text").trigger("click");
      }
    });

    $('#send_text').on("click",function(){
      
      var messageObject = $("#text").val();
      //console.log(messageObject);
      // var toChatID = $("#target").val();
      // messageObject.toChatID = toChatID;
      // if(toChatID == 0)
      // {
      //   messageObject.action = "group";
      // }
      // else
      // {
      //   messageObject.action = "message";
      // }
      // messageObject.content = $("#text").val();
      //console.log(messageObject);
      doSend(messageObject);
      //doSend($("#text").val());
      $("#text").val('');

    });



  }

  function onOpen(evt)
  {
    writeToScreen("CONNECTED");
    //doSend("message test");
    //console.log(messageFormat);
    // doSend(register);

  }

  function onClose(evt)
  {
    writeToScreen("DISCONNECTED");
  }

  function onMessage(evt)
  {
    // writeToScreen(evt.data);
    var jsonObj = JSON.parse(evt.data);
    console.log(evt.data);
    // if (jsonObj.action != "system")
    // {
    //   var message = jsonObj.content;
    //   var fromChatID = jsonObj.fromChatID;
    //   if (!fromChatID)
    //   {
    //     fromChatID = '系統公告';
    //   }
    //   writeToScreen('<span style="color: blue;">' + fromChatID + ': ' + message+'</span>');  
    // } else {
    //   updateUserList(jsonObj.data);
    // }
    
    
    //websocket.close();
  }


  function updateUserList(userListArray)
  {
    $("#target").html('');
    $("#target").append('<option value="0">全部</option>');
    for (userName of userListArray) 
    {
      if(mySetting.id != userName)
      {
        $("#target").append('<option value="'+userName+'">'+userName+'</option>');
      }
    }
  }

  function onError(evt)
  {
    writeToScreen('<span style="color: red;">ERROR:</span> ' + evt.data);
  }

  function doSend(obj)
  {
    // if (obj.content.length != 0)
    // {
      if (obj.action == "message")
      {
        writeToScreen(mySetting.id + ': ' + obj.content);  
      }
      websocket.send(obj);      
    // }
    
  }

  function writeToScreen(message)
  {
    var pre = document.createElement("p");
    pre.style.wordWrap = "break-word";
    pre.innerHTML = message;


    output.appendChild(pre);

    if ($("#output > p").length >= 10)
    {
      $('#output').scrollTop($('#output')[0].scrollHeight);
    }

  }




  window.addEventListener("load", init, false);




  </script>
  <div id="container">
    <h2>WebSocket Test</h2>
    <div style="overflow:scroll; height:400px;">
      <div id="output"  style="overflow:auto; height:400px;"></div>
    </div>
    <div style="position: absolute;top:410;">
    
    <select name="target" id="target">
    </select>  

    <textarea id="text" cols="50" rows="5"></textarea>
    
    <input type="submit" id="send_text">

    </div>
  </div>